/* (C) Copyright 1984,85,86,87 Walter L. Peacock	All Rights Reserved	 */
/* a d j s t a c k . c												*/

/*---------------------------------------------------------------------------- 
 * adjstack() is called by btrdelet() to adjust CBTREE's internal index 
 * node stack.  When there are duplicate keys, CBTREE will use the index node 
 * fwdpage pointer to get to the next sequential index node.  When this 
 * occurs during deletes, the stack needs to be adjusted also in case the 
 * index is modified by cpyltbro(), or cmptnode().
 *---------------------------------------------------------------------------*/

#include "cbtree.h"

void adjstack(fdidx, idxblk, node, btparmst)
int fdidx;
long node;
struct btcommo *btparmst;
struct btidxblk *idxblk;
{
	extern void free();
	extern int	sp;
	register int j;
	int stk, hdrloc;
	char *calloc();
	extern long poptop();
	long stknode, *stktbl;

	if((char *)(stktbl = (long *)
									calloc((uint)sp+1, (uint)sizeof(long))) == NULL)
		ckerror(- CK_NOMEM, "46");

	/* empty stack into table */
	stk = 0;
	while ( (stktbl[stk] = poptop() ) != (long) NULL)
		stk++;

	/* first make sure that we have the right record	*/

	j = 0;
	stknode = node;

	while (j < stk) {
		/* read upper level node. check for crossing upper level node */
		if (stktbl[j])
			getidxr(fdidx, stktbl[j], idxblk, btparmst->btidxlen, btparmst->btkeylen);

		/* search upper level node on the stack for located node in btrdelet */
		for(hdrloc = 0; hdrloc < idxblk->cellicnt; hdrloc++){
			if (idxblk->btpage[hdrloc].btptr == stknode)
				break;
		}

		if (idxblk->btpage[hdrloc].btptr != stknode){
			/* new upper level node so adjust stack */
			if (idxblk->fwdpage > 0)
				stktbl[j] = idxblk->fwdpage;
			else{   /* now check upper level for this level node */
				stknode = stktbl[j];
				j++;
			}
		}
		else{   /* now check upper level */
			stknode = stktbl[j];
			j++;
		}
	}

	while (stk-- > 0)
		pushdown(stktbl[stk]);

	FREE(stktbl);
}
